import 'package:librus_api/librus_api_base.dart';
import 'package:reflectable/reflectable.dart';

typedef S ItemCreator<S>();

class Activator {
  static dynamic findStaticAndInvoke(o, String name) {
    ClassMirror r = reflector.reflect(o).type;
    MethodMirror sFn;
    var s = new Symbol(name);

    while (sFn == null && r != null) {
      sFn = r.staticMembers[s];
      if (sFn != null) {
        break;
      }
      r = r.superclass;
    }

    if (sFn != null) {
      if (sFn.isGetter) {
        return r.invokeGetter(name);
      } else {
        return r.invoke(name, []);
      }
    }
  }
}

String decapitalize(String input) {
  if (input == null) {
    throw new ArgumentError("string: $input");
  }
  if (input.length == 0) {
    return input;
  }
  return input[0].toLowerCase() + input.substring(1);
}

String capitalize(String input) {
  if (input == null) {
    throw new ArgumentError("string: $input");
  }
  if (input.length == 0) {
    return input;
  }
  return input[0].toUpperCase() + input.substring(1);
}
