import 'package:librus_api/librus_api.dart';
import 'package:librus_api/librus_api_base.dart';
import 'package:reflectable/mirrors.dart';

@reflector
abstract class Serializable {
  Map toJson() {
    try {
      Map map = new Map();
      InstanceMirror im = reflector.reflect(this);
      ClassMirror cm = im.type;
      var decls = cm.declarations.values
          .where((dm) => dm is VariableMirror)
          .where((dm) => !dm.isPrivate)
          .where((dm) => !im.type.staticMembers.keys.contains(dm.simpleName));
      decls.forEach((dm) {
        map[dm.simpleName] = im.invokeGetter(dm.simpleName);
      });
      return map;
    } catch (err, stacktrace) {
      print(err);
      print(stacktrace);
    }
  }
}
